#include <stdio.h>
#include <unistd.h>
#include <asm/io.h>
#include <stdio.h>
#include <string.h>

#define PORT 0x378 /* lp1 */

/*
	Código C do GNU/PraQuePrego
*/

char state;

void moto (unsigned char motor, int tsleep) {
	unsigned char mask;
	unsigned char offset = motor;

	int i;

	if (motor >= 16)
		mask = 15;
	else
		mask = 240;

	for (i = 0 ; i < 4 ; i++, offset = offset << 1) {
		state = (state & mask) | offset;
		outb (state, PORT);
		usleep (tsleep);
	}
}

void umoto (unsigned char motor, int tsleep) {
	unsigned char floor;
	unsigned char offset = motor;
	unsigned char mask;

	int i;

	if (motor < 16) {
		floor = 0;
		mask = 240;
	}
	else {
		floor = 8;
		mask = 15;
	}

	while (offset > floor) {
		state = (state & mask) | offset;
		outb (state, PORT);
		usleep (tsleep);

		offset = offset >> 1;
	}
}

/* motor, sleep_time, direção, passos */
int main(int argc, char **argv)
{
	state = 0;
	char *end;

	int m = strtol(argv[1], &end, 10);
	int s = strtol(argv[2], &end, 10);
	int i = strtol(argv[3], &end, 10);
	char d = argv[4][0];
	state = strtol(argv[5], &end, 10);

	ioperm (PORT, 1, 1);
	outb (0x00, PORT);

	switch (d) {
		case 'a':
			while (i--)
				moto (m, s);
			break;
		case 'h':
			while (i--)
				umoto (m, s);
			break;
	}
	
	ioperm (PORT, 1, 0);

	printf ("%d", state);

	return 0;
}
